Index: orxonox/trunk/src/orxonox.cc
===================================================================
--- orxonox/trunk/src/orxonox.cc	(revision 2077)
+++ orxonox/trunk/src/orxonox.cc	(revision 2190)
@@ -21,54 +21,39 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer:
-*/
-
-#include <iostream>
-#include <cstdio>
-#include <GL/glut.h>
-
-#include "environment.h"
+   co-programmer: Christian Meyer
+*/
+
+#include "orxonox.h"
 #include "world.h"
-#include "input_output.h"
+#include "camera.h"
 #include "data_tank.h"
-#include "stdincl.h"
-#include "player.h"
-#include "npc.h"
-#include "shoot_laser.h"
-
-#include "orxonox.h"
+#include "command_node.h"
+#include <string.h>
 
 using namespace std;
 
-
-Orxonox::Orxonox () 
+/**
+	\brief create a new Orxonox
+*/
+Orxonox::Orxonox ()
 {
   pause = false;
 }
 
-
-
+/**
+	\brief remove Orxonox from memory
+*/
 Orxonox::~Orxonox () 
-{}
-
-
-/* this is a singleton class to prevent dublicates */
+{
+	Orxonox::singleton_ref = NULL;
+	if( world != NULL) delete world;
+	if( localinput != NULL) delete world;
+	if( localcamera != NULL) delete localcamera;
+	if( resources != NULL) delete resources;
+}
+
+
+/* this is a singleton class to prevent duplicates */
 Orxonox* Orxonox::singleton_ref = 0;
-World* Orxonox::world = 0;
-InputOutput* Orxonox::io = 0;
-Player* Orxonox::localPlayer = 0;
-bool Orxonox::pause = false;
-bool Orxonox::inputEnabled = false;
-bool Orxonox::upWeGo = false;
-bool Orxonox::downWeGo = false;
-bool Orxonox::rightWeGo = false;
-bool Orxonox::leftWeGo = false;
-bool Orxonox::shoot1 = false;
-int Orxonox::fps = 0;
-int Orxonox::alpha = 0;
-int Orxonox::beta = 0;
-//int Orxonox::offsetX = 0;
-//int Orxonox::offsetY = 0;
-
 
 Orxonox* Orxonox::getInstance (void)
@@ -79,262 +64,314 @@
 }
 
-
-int Orxonox::globalInit (int argc, char** argv) 
-{
-  glutInit(&argc, argv);
-  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
+/**
+	\brief this finds the config file
+	
+	Since the config file varies from user to user and since one may want to specify different config files
+	for certain occasions or platforms this function finds the right config file for every occasion and stores
+	it's path and name into configfilename
+*/
+void Orxonox::get_config_file (int argc, char** argv)
+{
+/*	char* path;
+	#ifdef __WIN32__
+	path = getenv("");
+	#else
+	path = getenv("HOME");
+	#endif
+	
+	if( path != NULL) strcpy (configfilename, path);
+	else strcpy (configfilename, "./");
+	strcat (configfilename, "/.orxonox.conf");*/
+	
+	strcpy (configfilename, "orxonox.conf");
+}
+
+/**
+	\brief initialize Orxonox with command line
+*/
+int Orxonox::init (int argc, char** argv)
+{
+		// parse command line
+		// config file
+		
+	get_config_file (argc, argv);
+	
+		// initialize SDL
+  printf("> Initializing SDL\n");
+  if( SDL_Init (SDL_INIT_EVERYTHING) == -1)
+  {
+    printf ("Could not SDL_Init(): %s\n", SDL_GetError());
+    return -1;
+  }
+  
+  	// initialize everything
+  printf("> Initializing video\n");
+	if( init_video () == -1) return -1;
+  printf("> Initializing sound\n");
+	if( init_sound () == -1) return -1;
+  printf("> Initializing input\n");
+	if( init_input () == -1) return -1;
+  printf("> Initializing networking\n");
+	if( init_networking () == -1) return -1;
+  printf("> Initializing resources\n");
+	if( init_resources () == -1) return -1;
+  printf("> Initializing world\n");
+	if( init_world () == -1) return -1;
+	
+	return 0;
+}
+
+/**
+	\brief initializes SDL and OpenGL
+*/
+int Orxonox::init_video () 
+{
+  // Set video mode
+  // TO DO: parse arguments for settings
+  SDL_GL_SetAttribute (SDL_GL_RED_SIZE, 5);
+  SDL_GL_SetAttribute (SDL_GL_GREEN_SIZE, 5);
+  SDL_GL_SetAttribute (SDL_GL_BLUE_SIZE, 5);
+  SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 16);
+  
+  int bpp = 16;
+  int width = 640;
+  int height = 480;
+  Uint32 flags = SDL_HWSURFACE | SDL_OPENGL | SDL_GL_DOUBLEBUFFER;
+  
+  if( (screen = SDL_SetVideoMode (width, height, bpp, flags)) == NULL)
+  {
+    printf ("Could not SDL_SetVideoMode(%d, %d, %d, %d): %s\n", width, height, bpp, flags, SDL_GetError());
+    SDL_Quit();
+    return -1;
+  }
+  
+  // Set window labeling
+  // TO DO: Add version information to caption
+  SDL_WM_SetCaption( "Orxonox", "Orxonox");
+  
+  // TO DO: Create a cool icon and use it here
+  // SDL_WM_SetIcon(SDL_Surface *icon, Uint8 *mask);  
+
+  // OpenGL stuff
+  // (Is this all we initialize globally???)
+  glClearColor(0.0, 0.0, 0.0, 0.0);
   glEnable(GL_DEPTH_TEST);
-  glutInitWindowSize(500, 500);
-  //glutFullScreen();
-  glutInitWindowPosition(100, 100);
-  glutCreateWindow("OrxonoX");
+  glEnable(GL_COLOR);
   glShadeModel(GL_FLAT);
-  /* window event dispatchers */
-  glutDisplayFunc(display);
-  glutReshapeFunc(reshape);
-  glutKeyboardFunc(keyboard);
-  glutKeyboardUpFunc(upKeyboard);
-
-  glutTimerFunc(1000, timeSlice, 0);
-  cout << "measuring performance...";
-}
-
-
-int Orxonox::menuInit (void)
-{
-  glClearColor(0.0, 0.0, 0.0, 0.0);
-}
-
-
-int Orxonox::gameInit (void) 
-{
-  glClearColor(0.0, 0.0, 0.0, 0.0);
-  
-  /* world init, shouldnt be done here later */
-  world = new World;
-  (*world).initEnvironement();
-  localPlayer = new Player;
-  localPlayer->setPosition(0.0, -10.0, 3.0);
-  localPlayer->setCollisionRadius(2.0);
-  io = new InputOutput(world, localPlayer);
-  (*world).addPlayer(localPlayer);
-  Environment *env = new Environment;
-  (*world).addEnv(env);
-  NPC* npc = new NPC;
-  npc->setPosition(3.0, 0.0, 3.0);
-  npc->setCollisionRadius(1.0);
-  world->addNPC(npc);
-
-  NPC* npc2 = new NPC;
-  npc2->setPosition(-2.0, 10.0, 3.0);
-  npc2->setCollisionRadius(1.0);
-  world->addNPC(npc2);
-
-  glutSpecialFunc(specFunc); 
-  glutSpecialUpFunc(releaseKey);
-
-  glutIdleFunc(continousRedraw);
-  //cout << "Orxonox::gameInit" << endl;
-}
-
-
-/* this is the time triggered function. heart beat*/
-
-void Orxonox::timeSlice(int value)
-{
-  cout << "got " << fps << " fps" << endl;
-  /* this is very very unsafe: io could be uninit */
-  io->setPlayerStep(19.2/fps); /* set player to propper speed */
-  localPlayer->shootLaser->setShootStep(20.0/fps); /* set shoot speed */
-  world->setWorldStep(7.0/fps); /* set the speed of the terrain moving away */
-  fps = 0;
-  inputEnabled = true;
-  glutTimerFunc(1000, timeSlice, 0);
-}
-
-
-
-void Orxonox::keyboard(unsigned char key, int x, int y)
-{
-  switch(key) {
-
-    /* perspectiv control */
-  case 'w':
-    beta -= 1;
-    break;
-  case 's':
-    beta += 1;
-    break;
-  case 'a':
-    alpha -= 1;
-    break;
-  case 'd':
-    alpha += 1;
-    break;
-
-    /* game controls */
-  case 'p':
-    if (pause) 
-      {
-	cout << "unset pause" << endl;
-	glutIdleFunc(continousRedraw);
-	pause = false;
-      }
-    else 
-      {
-	cout << "set pause" << endl;
-	glutIdleFunc(NULL);
-	pause = true;
-      }
-    break;
-  case 32:
-    shoot1 = true;
-    break;
-  case 27:
-  case 'q':
-    quitGame();
-    break;
+  
+  // create camera
+  localcamera = new Camera();
+  
+  return 0;
+}
+
+/**
+	\brief initializes the sound engine
+*/
+int Orxonox::init_sound () 
+{
+	printf("Not yet implemented\n");
+	return 0;
+}
+
+/**
+	\brief initializes input functions
+*/
+int Orxonox::init_input () 
+{
+	// create localinput
+	localinput = new CommandNode( configfilename);
+	
+	return 0;
+}
+
+/**
+	\brief initializes network system
+*/
+int Orxonox::init_networking () 
+{
+	printf("Not yet implemented\n");
+	return 0;
+}
+
+/**
+	\brief initializes and loads resource files
+*/
+int Orxonox::init_resources () 
+{
+	printf("Not yet implemented\n");
+	return 0;
+}
+
+/**
+	\brief initializes the world
+*/
+int Orxonox::init_world () 
+{
+	world = new World();
+	
+	// TO DO: replace this with a menu/intro
+	world->load_debug_level();
+	
+	return 0;
+}
+
+/**
+	\brief exits Orxonox
+*/
+void Orxonox::quitGame() 
+{
+	bQuitOrxonox = true;
+}
+
+/**
+	\brief this runs all of Orxonox
+*/
+void Orxonox::mainLoop()
+{
+	lastframe = SDL_GetTicks();
+	bQuitOrxonox = false;
+  // This is where everything is run
+printf("Orxonox|Entering main loop\n");
+  while( !bQuitOrxonox)
+  {
+  	// Network
+  	synchronize();
+    // Process input
+    handle_input();
+    // Process time
+    time_slice();
+    // Process collision
+    collision();
+    // Draw
+    display();
   }
-}
-
-
-void Orxonox::upKeyboard(unsigned char key, int x, int y) 
-{
-  switch(key) {
-  case 32:
-    shoot1 = false;
-    break;
-  }
-}
-
-
-void Orxonox::quitGame() 
-{
-  //cout << "finished garbage colletion, quitting..." << endl;
-  exit(0);
-}
-
-
-void Orxonox::releaseKey(int key, int x, int y) 
-{  
-  switch(key) {
-  case GLUT_KEY_UP:
-    upWeGo = false;
-    break;
-  case GLUT_KEY_DOWN:
-    downWeGo = false;
-    break;
-  case GLUT_KEY_RIGHT:
-    rightWeGo = false;
-    break;
-  case GLUT_KEY_LEFT:
-    leftWeGo = false;
-    break;
-  }
-}
-
-
-/** 
-   \brief special keys function. called by glut
-   
-   Here are all special key function defined.
-*/
-void Orxonox::specFunc(int key, int x, int y)
-{
-  switch(key) {
-    /* spacecraft controls */
-  case GLUT_KEY_UP:
-    upWeGo = true;
-    break;
-  case GLUT_KEY_DOWN:
-    downWeGo = true;
-    break;
-  case GLUT_KEY_RIGHT:
-    rightWeGo = true;
-    break;
-  case GLUT_KEY_LEFT:
-    leftWeGo = true;
-    break;
-  }
-}
-
-
-void Orxonox::display() 
-{
-  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-
-  glColor3f(0.0, 0.5, 0.6);
-  glLoadIdentity();
-  gluLookAt(0.0, -14.0, 15.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
-  (*world).drawWorld();
-
-  glutSwapBuffers();
-} 
-
-
-void Orxonox::continousRedraw()
-{
-  /* increment the frames-per-second counter*/
-  fps++;
-  /* check for collisions */
-  world->detectCollision();
-
-  /* check for input to pass it over */
-  if ( !pause && inputEnabled && 
-       (rightWeGo || leftWeGo || upWeGo || downWeGo || shoot1)) 
-    {
-      if (upWeGo)
-	(*io).goUp();
-      if (downWeGo)
-      (*io).goDown();
-      if (rightWeGo)
-	(*io).goRight();
-      if (leftWeGo)
-      (*io).goLeft();
-      if (shoot1) 
-	(*io).shoot();
-    }
-  /* request repaint */
-  glutPostRedisplay();
-  //cout << "Orxonox::continousRedraw" << endl;
-}
-
-
-void Orxonox::reshape (int w, int h)
-{
-  glViewport(0, 0, (GLsizei) w, (GLsizei) h);
-  glMatrixMode(GL_PROJECTION);
-  glLoadIdentity();
-  glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 200.0);
-  glMatrixMode(GL_MODELVIEW);
-  glLoadIdentity(); //pb why a second time?
-}
-
-
-void Orxonox::testTheShit() 
-{
-  //Player* pl = new Player;
-  //(*pl).setPosition(1, 1, 1);
-  //(*world).addPlayer(pl);
-  
-  //NPC* nl = new NPC;
-  //(*world).addNPC(nl);
-  //(*world).addNPC(nl);
-  //(*world).addNPC(nl);
-  //(*world).addNPC(nl);
-  //(*world).addNPC(nl);
-  //(*world).addNPC(nl);
-  //(*world).testThaTest();
-}
-
+printf("Orxonox|Exiting the main loop\n");
+}
+
+/**
+	\brief handles sprecial events from localinput
+	\param event: an event not handled by the CommandNode 
+*/
+void Orxonox::event_handler (SDL_Event* event)
+{
+	// Handle special events such as reshape, quit, focus changes
+}
+
+/**
+	\brief synchronize local data with remote data
+*/
+void Orxonox::synchronize ()
+{
+	// Get remote input
+	// Update synchronizables
+}
+
+/**
+	\brief run all input processing
+*/
+void Orxonox::handle_input ()
+{
+	// localinput
+		localinput->process();
+	// remoteinput
+}
+
+/**
+	\brief advance the timeline
+*/
+void Orxonox::time_slice ()
+{
+	Uint32 curframe = SDL_GetTicks();
+	if( !pause)
+	{
+		world->time_slice (curframe - lastframe);
+		world->update ();
+		localcamera->time_slice (curframe - lastframe);
+	}
+	lastframe = curframe;
+}
+
+/**
+	\brief compute collision detection
+*/
+void Orxonox::collision ()
+{
+	world->collide ();
+}
+
+/**
+	\brief handle keyboard commands that are not meant for WorldEntities
+	\param cmd: the command to handle
+	\return true if the command was handled by the system or false if it may be passed to the WorldEntities
+*/
+bool Orxonox::system_command (Command* cmd)
+{
+	if( !strcmp( cmd->cmd, "quit"))
+	{
+		if( !cmd->bUp) bQuitOrxonox = true;
+		return true;
+	}
+	return false;
+}
+
+/**
+	\brief render the current frame
+*/
+void Orxonox::display ()
+{
+		// clear buffer
+	glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
+		// set camera
+	localcamera->apply ();
+		// draw world
+	world->draw ();
+		// draw HUD
+		// flip buffers
+	SDL_GL_SwapBuffers();
+}
+
+/**
+	\brief retrieve a pointer to the local Camera
+	\return a pointer to localcamera
+*/
+Camera* Orxonox::get_camera ()
+{
+	return localcamera;
+}
+
+/**
+	\brief retrieve a pointer to the local CommandNode
+	\return a pointer to localinput
+*/
+CommandNode* Orxonox::get_localinput ()
+{
+	return localinput;
+}
+
+/**
+	\brief retrieve a pointer to the local World
+	\return a pointer to world
+*/
+World* Orxonox::get_world ()
+{
+	return world;
+}
 
 int main (int argc, char** argv) 
 {  
+	printf(">>> Starting Orxonox <<<\n");
   Orxonox *orx = Orxonox::getInstance();
-  (*orx).globalInit(argc, argv);
-  //(*orx).menuInit(); pb: directly jump to the game, no menu
-  (*orx).gameInit();
-
-  glutMainLoop();  
+  
+  if( (*orx).init(argc, argv) == -1)
+  {
+    printf("! Orxonox initialization failed\n");
+    return -1;
+  }
+	
+  (*orx).mainLoop();
+
+  //delete orx;
+  
   return 0;
 }
Index: orxonox/trunk/src/orxonox.conf
===================================================================
--- orxonox/trunk/src/orxonox.conf	(revision 2190)
+++ orxonox/trunk/src/orxonox.conf	(revision 2190)
@@ -0,0 +1,11 @@
+[Bindings]
+UP=up
+DOWN=down
+LEFT=left
+RIGHT=right
+SPACE=fire
+ESCAPE=quit
+q=quit
+BUTTON_LEFT=fire
+BUTTON_RIGHT=altfire
+b=benscho
Index: orxonox/trunk/src/orxonox.h
===================================================================
--- orxonox/trunk/src/orxonox.h	(revision 2077)
+++ orxonox/trunk/src/orxonox.h	(revision 2190)
@@ -1,11 +1,23 @@
+/*! 
+    \file orxonox.h
+    \brief Orxonox core functions
+*/ 
 
 #ifndef ORXONOX_H
 #define ORXONOX_H
 
+#include <SDL/SDL.h>
+
+#include "stdincl.h"
+
+class CommandNode;
+class WorldEntity;
+class DataTank;
 class World;
-class InputOutput;
-class Player;
+class Camera;
 
-
+//! Orxonox core singleton class
+/**
+*/
 class Orxonox {
 
@@ -14,38 +26,47 @@
   Orxonox ();
   ~Orxonox ();
-  static World* world;
-  static InputOutput* io;
-  static Player* localPlayer;
-  static bool pause;
-  static bool inputEnabled;
-  static bool upWeGo;
-  static bool downWeGo;
-  static bool rightWeGo;
-  static bool leftWeGo;
-  static bool shoot1;
-  static int fps;
+  
+  char configfilename[256];
+  World* world;
+  DataTank* resources;
+  CommandNode* localinput;
+  Camera* localcamera;
+  SDL_Surface* screen;
+  
+  bool bQuitOrxonox;
+  bool pause;
+	Uint32 lastframe;
 
-  static int alpha;
-  static int beta;
-  static int offsetX;
-  static int offsetY;
+	void get_config_file (int argc, char** argv);
+	
+		// main loop functions
+  void synchronize ();
+  void handle_input ();
+  void time_slice ();
+  void collision ();
+  void display ();
+  
+  	// subsystem initialization
+  int init_video ();
+  int init_sound ();
+  int init_input ();
+  int init_networking ();
+  int init_resources ();
+  int init_world ();
+  
+ public:
+  static Orxonox* getInstance ();
+  void quitGame();
 
-  static void timeSlice(int value);
+  void event_handler (SDL_Event* event);
+  bool system_command (Command* cmd);
 
- public:
-  static Orxonox* getInstance (void);
-
-  int globalInit (int argc, char** argv);
-  int menuInit (void);
-  int gameInit (void);
-  void testTheShit(void);
-  static void display (void);
-  static void continousRedraw(void);
-  static void reshape (int w, int h);
-  static void keyboard(unsigned char key, int x, int y);
-  static void upKeyboard(unsigned char key, int x, int y);
-  static void releaseKey(int key, int x, int y);
-  static void specFunc(int key, int x, int y);
-  static void quitGame(void); 
+  int init (int argc, char** argv);
+	
+	CommandNode* get_localinput();
+	Camera* get_camera();
+	World* get_world();
+	
+  void mainLoop();
 };
 
Index: orxonox/trunk/src/player.cc
===================================================================
--- orxonox/trunk/src/player.cc	(revision 2077)
+++ orxonox/trunk/src/player.cc	(revision 2190)
@@ -13,118 +13,117 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer:
+   co-programmer: Christian Meyer
 */
 
-#include <iostream>
-#include <stdlib.h>
-#include <GL/glut.h>
-
-#include "shoot_laser.h"
-#include "shoot_rocket.h"
-#include "data_tank.h"
-
 #include "player.h"
+#include "stdincl.h"
+#include "collision.h"
 
 using namespace std;
 
 
-Player::Player() 
-   : WorldEntity() {
-  //cout << "Player::Player" << endl;
-  xCor = yCor = zCor = 0;
-  shootLaser = new ShootLaser;
-  shootRocket = new ShootRocket;
+Player::Player(bool isFree) : WorldEntity(isFree)
+{
 }
 
 Player::~Player () 
 {
-  //delete shootLaser;
 }
 
-
-void Player::setPosition( float x, float y, float z)
+void Player::post_spawn ()
 {
-  xCor = x; yCor = y; zCor = z;
+	travel_speed = 10.0;
+	velocity = Vector();
+	bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
+	bFire = false;
+	acceleration = 10.0;
+	set_collision (new CollisionCluster (1.0, Vector(0,0,0)));
 }
 
-
-void Player::getPosition(float* x, float* y, float* z)
+void Player::tick (float time)
 {
-  *x = xCor; *y = yCor; *z = zCor;
+	// movement
+	move (time);
 }
 
-
-void Player::setCollisionRadius(float radius) 
+void Player::hit (WorldEntity* weapon, Vector loc)
 {
-  collisionRadius = radius;
 }
 
-
-void Player::goX(float x) 
+void Player::destroy ()
 {
-  xCor += x;
 }
 
-
-void Player::goY(float y)
+void Player::collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags)
 {
-  yCor += y;
 }
 
-void Player::goZ(float z)
+void Player::command (Command* cmd)
 {
-  zCor += z;
+	printf("Player|recieved command [%s]\n", cmd->cmd);
+	if( !strcmp( cmd->cmd, "up")) bUp = !cmd->bUp;
+	else if( !strcmp( cmd->cmd, "down")) bDown = !cmd->bUp;
+	else if( !strcmp( cmd->cmd, "left")) bLeft = !cmd->bUp;
+	else if( !strcmp( cmd->cmd, "right")) bRight = !cmd->bUp;
+	else if( !strcmp( cmd->cmd, "fire")) bFire = !cmd->bUp;
 }
 
+void Player::draw ()
+{
+	glMatrixMode(GL_MODELVIEW);
+	glLoadIdentity();
+	float matrix[4][4];
 
-
-void Player::shoot(int n) 
-{
-
-  //  if (shootLaser->inhibitor++ <= 100)
-  shootLaser->addShoot(xCor, yCor, zCor);
-  // else if (shootLaser->inhibitor++ <= 200)
-  shootLaser->addShootExt(xCor, yCor, zCor, .1, .4, .0);
-  //  else if (shootLaser->inhibitor++ <= 300)
-  shootLaser->addShootExt(xCor, yCor, zCor, -0.1, .4, .0);
-  //  else
-  shootLaser->inhibitor =0;
-  
-  //  if (shootRocket->inhibitor++ >=80)
-  {
-    shootRocket->addBackParable(xCor, yCor, zCor);
-    shootRocket->addSideAcc(xCor, yCor, zCor, RIGHT);
-    shootRocket->addSideAcc(xCor, yCor, zCor, LEFT);
-    shootRocket->addRotater(xCor, yCor, zCor);
-    //  if (shootRocket->inhibitor >=90)
-    //        shootRocket->inhibitor =0;
-  }
-  //cout << "Player::shoot" << endl;
-  
-  /*
-  shootLaser->addShoot(xCor, yCor, zCor);
-  shootLaser->addShootExt(xCor, yCor, zCor, .1, .4, .0);
-  shootLaser->addShootExt(xCor, yCor, zCor, -0.1, .4, .0);
-  //shootRocket->addShoot(xCor, yCor, zCor);
-  //cout << "Player::shoot" << endl;
-  */
+	glTranslatef(get_placement()->r.x,get_placement()->r.y,get_placement()->r.z);
+  get_placement()->w.matrix (matrix);
+  glMultMatrixf ((float*)matrix);
+	
+	glBegin(GL_TRIANGLES);
+	glColor3f(1,0,0);
+	glVertex3f(0,0,0.5);
+	glColor3f(0,1,0);
+	glVertex3f(-0.5,0,-1);
+	glColor3f(0,0,1);
+	glVertex3f(0.5,0,-1);
+	glEnd();
+	
+	printf("Player@%f/%f/%f\n", get_placement()->r.x, get_placement()->r.y, get_placement()->r.z);
 }
 
+void Player::get_lookat (Location* locbuf)
+{
+	*locbuf = *get_location();
+	//locbuf->dist += 5.0;
+}
 
-//void Player::addIO(InputOutput *io) {}
+void Player::left_world ()
+{
+}
 
-
-void Player::paint() 
+void Player::move (float time)
 {
-  //cout << "Player::drawPlayer" << endl;
-  glPushMatrix();
-  glTranslatef(xCor, yCor, 3.0);
-  glScalef(1.0, 3.0, 1.0);
-  glutWireCube(1.0);
-  glPopMatrix();
-  /* draw all the shoots additionaly */
-  shootLaser->drawShoot();
-  shootRocket->drawShoot();
-  //cout << "Player::drawPlayer, end" << endl;
+	float xAccel, yAccel, zAccel;
+	xAccel = yAccel = zAccel = 0;
+	if( bUp) xAccel += acceleration;
+	if( bDown) xAccel -= acceleration;
+	if( bLeft) yAccel += acceleration;
+	if( bRight) yAccel -= acceleration;
+	if( bAscend) zAccel += acceleration;
+	if( bDescend) zAccel -= acceleration;
+	
+	Vector accel( xAccel, yAccel, zAccel);
+	
+	Location* l = get_location();
+	
+	// r(t) = r(0) + v(0)*t + 1/2*a*t^2
+	// r = position
+	// v = velocity
+	// a = acceleration
+	
+	l->pos = l->pos + velocity*time + (accel*(0.5*time*time));
+	l->dist += travel_speed * time;
+	
+	velocity = velocity + (accel * time);
+	printf("Player|velocity %f/%f/%f\n", velocity.x, velocity.y, velocity.z);
 }
 
@@ -146,10 +145,2 @@
 
 
-
-
-
-
-
-
-
-
Index: orxonox/trunk/src/player.h
===================================================================
--- orxonox/trunk/src/player.h	(revision 2077)
+++ orxonox/trunk/src/player.h	(revision 2190)
@@ -1,2 +1,6 @@
+/*! 
+    \file player.h
+    \brief Implements a basic controllable WorldEntity
+*/
 
 #ifndef PLAYER_H
@@ -5,41 +9,34 @@
 #include "world_entity.h"
 
-class ShootLaser;
-class ShootRocket;
-
-
+//! Basic controllable WorldEntity
 class Player : public WorldEntity 
 {
+	friend class World;
 
  public:
-  Player ();
+  Player (bool isFree = false);
   ~Player ();
 
-  /* position of the spacecraft */
-  float xCor;
-  float yCor;
-  float zCor;
+	virtual void post_spawn ();
+  virtual void tick (float time);
+  virtual void hit (WorldEntity* weapon, Vector loc);
+  virtual void destroy ();
+  virtual void collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags);
+ 	virtual void command (Command* cmd);
   
-  float collisionRadius;
+  virtual void draw ();
+  virtual void get_lookat (Location* locbuf);
 
-
-  /* this player wanna shoot? so include a ref to ShootLaser */
-  ShootLaser* shootLaser;
-  ShootRocket* shootRocket;
-
-  void setPosition(float x, float y, float z);
-  void getPosition(float* x, float* y, float* z);
-  void setCollisionRadius(float radius);
-  void paint();
-  void goX(float x);
-  void goY(float y);
-  void goZ(float x);
-  void shoot(int n);
-  //  void addIO(InputOutput *io);
-  void drawPlayer(void);
+	virtual void left_world ();
 
  private:
-
-
+ 	bool bUp, bDown, bLeft, bRight, bAscend, bDescend;
+ 	bool bFire;
+ 	Vector velocity;
+ 	float travel_speed;
+ 	float acceleration;
+ 	
+ 	void move (float time);
+ 	
 };
 
Index: orxonox/trunk/src/stdincl.h
===================================================================
--- orxonox/trunk/src/stdincl.h	(revision 2077)
+++ orxonox/trunk/src/stdincl.h	(revision 2190)
@@ -5,3 +5,15 @@
 #define null 0
 
+#ifdef __WIN32__
+#include <windows.h>
 #endif
+#include <SDL/SDL.h>
+#include <GL/gl.h>
+
+#include "vector.h"
+#include "coordinates.h"
+#include "list.h"
+#include "message_structures.h"
+#include "orxonox.h"
+
+#endif
Index: orxonox/trunk/src/track.cc
===================================================================
--- orxonox/trunk/src/track.cc	(revision 2190)
+++ orxonox/trunk/src/track.cc	(revision 2190)
@@ -0,0 +1,138 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christian Meyer
+   co-programmer: ...
+*/
+
+#include "track.h"
+
+using namespace std;
+
+/**
+	\brief creates a null Track part
+*/
+Track::Track ()
+{
+	ID = 0;
+	offset = NULL;
+	end = NULL;
+	nextID = 0;
+}
+
+/**
+	\brief creates a functional base Track part
+	\param number: the ID if this Track part
+	\param next: the ID of the next Track part
+	\param start: pointer to an anchor point (Vector) representing the offset of this part
+	\param finish: pointer to an anchor point (Vector) representing the end of this part
+*/
+Track::Track (Uint32 number, Uint32 next, Vector* start, Vector* finish)
+{
+	ID = number;
+	offset = start;
+	end = finish;
+	nextID = next;
+}
+
+/**
+	\brief removes the Track part from memory
+*/
+Track::~Track ()
+{
+}
+
+/**
+	\brief calculate a camera Placement from a "look at"-Location
+	\param lookat: the Location the camera should be centered on
+	\param camplc: pointer to a buffer where the new camera Placement should be put into
+	
+	Theoretically you can place the camera wherever you want, but for the sake of common sense I suggest that you at least
+	try to keep the thing that should be looked at inside camera boundaries.
+*/
+void Track::map_camera (Location* lookat, Placement* camplc)
+{
+	Line trace(*offset, *end - *offset);
+	float l = trace.len ();
+	
+//	camplc->r = *offset + Vector(0,0,0.5);
+//	camplc->w = Quaternion (trace.a, Vector(0,0,1));
+	float r = (lookat->dist)*PI / l;
+	camplc->r = trace.r + (trace.a * ((lookat->dist-10.0) / l)) + Vector(0,0,5.0);
+	camplc->w = Quaternion(Vector(0,0,0) - ((trace.r + (trace.a * ((lookat->dist) / l)) - camplc->r)), Vector(0,sin(r),cos(r)));
+	
+}
+
+/**
+	\brief calculate a Placement from a given Location
+	\param loc: the Location the entity is in
+	\param plc: a pointer to a buffer where the corresponding Placement should be put into
+	
+	There are no limitations to how you transform a Location into a Placement, but for the sake of placement compatibility between
+	track parts you should make sure that the resulting Placement at dist == 0 is equal to the offset Vector and the Placement at
+	dist == len() is equal to the end Vector. Elseway there will be ugly artifacts when transfering between track parts.
+*/
+bool Track::map_coords (Location* loc, Placement* plc)
+{
+	Line trace(*offset, *end - *offset);
+	float l = trace.len ();
+	
+	if( loc->dist > l)
+	{
+		loc->dist -= l;
+		loc->part = nextID;
+		return true;
+	}
+	
+	Quaternion dir(trace.a, Vector(0,0,1));
+	
+	plc->r = trace.r + (trace.a * ((loc->dist) / l)) + /*dir.apply*/(loc->pos);
+	plc->w = dir * loc->rot;
+	
+	return false;
+}
+
+/**
+	\brief this is called when a WorldEntity enters a Track part
+	\param entity: pointer to the WorldEntity in question
+	
+	You can do stuff like add or remove effects, do some coordinate finetuning or whatever in here.
+*/
+void Track::post_enter (WorldEntity* entity)
+{
+}
+
+/**
+	\brief this is called when a WorldEntity leaves a Track part
+	\param entity: pointer to the WorldEntity in question
+	
+	You can do stuff like add or remove effects, do some coordinate finetuning or whatever in here.
+*/
+void Track::post_leave (WorldEntity* entity)
+{
+}
+
+/**
+	\brief this is called every frame
+	\param deltaT: amount of time passed since the last frame in seconds
+	
+	Do time based or polling scripts here. 
+*/
+void Track::tick (float deltaT)
+{
+}
+
+
+
+
+
Index: orxonox/trunk/src/track.h
===================================================================
--- orxonox/trunk/src/track.h	(revision 2190)
+++ orxonox/trunk/src/track.h	(revision 2190)
@@ -0,0 +1,36 @@
+/*! 
+    \file track.h
+    \brief Basic level architecture
+*/ 
+
+#ifndef TRACK_H
+#define TRACK_H
+
+#include "stdincl.h"
+
+//!	The Red Line through a level
+/**
+	Handles level boundaries, bound movement mapping, camera placement and scripting.
+	To create special levels with special camera movement, rules or whatever, derive from this base class.
+*/
+class Track 
+{
+ private:
+ 	Uint32 ID;
+ 	Vector* offset;
+ 	Vector* end;
+ 	Uint32 nextID;
+ 	
+ public:
+ 	Track ();
+  Track (Uint32 number, Uint32 next, Vector* start, Vector* finish);
+  ~Track ();
+	
+	virtual void post_enter (WorldEntity* entity);	// handle coordinate transition in here !!! (when dist < 0 or dist > lasttracklenght)
+	virtual void post_leave (WorldEntity* entity);
+	virtual void tick (float deltaT);
+	virtual void map_camera (Location* lookat, Placement* camplc);
+	virtual bool map_coords (Location* loc, Placement* plc);	// this should return true if the entity left track boundaries
+};
+
+#endif
